install.sh 8.4 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  30. esac
  31. }
  32. echo "arch: $(arch)"
  33. os_version=""
  34. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  35. if [[ "${release}" == "arch" ]]; then
  36. echo "Your OS is Arch Linux"
  37. elif [[ "${release}" == "manjaro" ]]; then
  38. echo "Your OS is Manjaro"
  39. elif [[ "${release}" == "armbian" ]]; then
  40. echo "Your OS is Armbian"
  41. elif [[ "${release}" == "centos" ]]; then
  42. if [[ ${os_version} -lt 8 ]]; then
  43. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  44. fi
  45. elif [[ "${release}" == "ubuntu" ]]; then
  46. if [[ ${os_version} -lt 20 ]]; then
  47. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  48. fi
  49. elif [[ "${release}" == "fedora" ]]; then
  50. if [[ ${os_version} -lt 36 ]]; then
  51. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  52. fi
  53. elif [[ "${release}" == "debian" ]]; then
  54. if [[ ${os_version} -lt 11 ]]; then
  55. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  56. fi
  57. elif [[ "${release}" == "almalinux" ]]; then
  58. if [[ ${os_version} -lt 9 ]]; then
  59. echo -e "${red} Please use AlmaLinux 9 or higher ${plain}\n" && exit 1
  60. fi
  61. elif [[ "${release}" == "rocky" ]]; then
  62. if [[ ${os_version} -lt 9 ]]; then
  63. echo -e "${red} Please use Rocky Linux 9 or higher ${plain}\n" && exit 1
  64. fi
  65. elif [[ "${release}" == "oracle" ]]; then
  66. if [[ ${os_version} -lt 8 ]]; then
  67. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  68. fi
  69. else
  70. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  71. echo "Please ensure you are using one of the following supported operating systems:"
  72. echo "- Ubuntu 20.04+"
  73. echo "- Debian 11+"
  74. echo "- CentOS 8+"
  75. echo "- Fedora 36+"
  76. echo "- Arch Linux"
  77. echo "- Manjaro"
  78. echo "- Armbian"
  79. echo "- AlmaLinux 9+"
  80. echo "- Rocky Linux 9+"
  81. echo "- Oracle Linux 8+"
  82. exit 1
  83. fi
  84. install_base() {
  85. case "${release}" in
  86. centos | almalinux | rocky | oracle)
  87. yum -y update && yum install -y -q wget curl tar tzdata
  88. ;;
  89. fedora)
  90. dnf -y update && dnf install -y -q wget curl tar tzdata
  91. ;;
  92. arch | manjaro)
  93. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  94. ;;
  95. *)
  96. apt-get update && apt install -y -q wget curl tar tzdata
  97. ;;
  98. esac
  99. }
  100. # This function will be called when user installed x-ui out of security
  101. config_after_install() {
  102. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  103. read -p "Do you want to continue with the modification [y/n]?": config_confirm
  104. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  105. read -p "Please set up your username:" config_account
  106. echo -e "${yellow}Your username will be:${config_account}${plain}"
  107. read -p "Please set up your password:" config_password
  108. echo -e "${yellow}Your password will be:${config_password}${plain}"
  109. read -p "Please set up the panel port:" config_port
  110. echo -e "${yellow}Your panel port is:${config_port}${plain}"
  111. echo -e "${yellow}Initializing, please wait...${plain}"
  112. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  113. echo -e "${yellow}Account name and password set successfully!${plain}"
  114. /usr/local/x-ui/x-ui setting -port ${config_port}
  115. echo -e "${yellow}Panel port set successfully!${plain}"
  116. else
  117. echo -e "${red}cancel...${plain}"
  118. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  119. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  120. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  121. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp}
  122. echo -e "this is a fresh installation,will generate random login info for security concerns:"
  123. echo -e "###############################################"
  124. echo -e "${green}username:${usernameTemp}${plain}"
  125. echo -e "${green}password:${passwordTemp}${plain}"
  126. echo -e "###############################################"
  127. echo -e "${red}if you forgot your login info,you can type x-ui and then type 8 to check after installation${plain}"
  128. else
  129. echo -e "${red} this is your upgrade,will keep old settings,if you forgot your login info,you can type x-ui and then type 8 to check${plain}"
  130. fi
  131. fi
  132. /usr/local/x-ui/x-ui migrate
  133. }
  134. install_x-ui() {
  135. cd /usr/local/
  136. if [ $# == 0 ]; then
  137. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  138. if [[ ! -n "$last_version" ]]; then
  139. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  140. exit 1
  141. fi
  142. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  143. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz
  144. if [[ $? -ne 0 ]]; then
  145. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  146. exit 1
  147. fi
  148. else
  149. last_version=$1
  150. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz"
  151. echo -e "Beginning to install x-ui $1"
  152. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  153. if [[ $? -ne 0 ]]; then
  154. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  155. exit 1
  156. fi
  157. fi
  158. if [[ -e /usr/local/x-ui/ ]]; then
  159. systemctl stop x-ui
  160. rm /usr/local/x-ui/ -rf
  161. fi
  162. tar zxvf x-ui-linux-$(arch).tar.gz
  163. rm x-ui-linux-$(arch).tar.gz -f
  164. cd x-ui
  165. chmod +x x-ui
  166. # Check the system's architecture and rename the file accordingly
  167. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  168. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  169. chmod +x bin/xray-linux-arm
  170. fi
  171. chmod +x x-ui bin/xray-linux-$(arch)
  172. cp -f x-ui.service /etc/systemd/system/
  173. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  174. chmod +x /usr/local/x-ui/x-ui.sh
  175. chmod +x /usr/bin/x-ui
  176. config_after_install
  177. systemctl daemon-reload
  178. systemctl enable x-ui
  179. systemctl start x-ui
  180. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  181. echo -e ""
  182. echo -e "x-ui control menu usages: "
  183. echo -e "----------------------------------------------"
  184. echo -e "x-ui - Enter Admin menu"
  185. echo -e "x-ui start - Start x-ui"
  186. echo -e "x-ui stop - Stop x-ui"
  187. echo -e "x-ui restart - Restart x-ui"
  188. echo -e "x-ui status - Show x-ui status"
  189. echo -e "x-ui enable - Enable x-ui on system startup"
  190. echo -e "x-ui disable - Disable x-ui on system startup"
  191. echo -e "x-ui log - Check x-ui logs"
  192. echo -e "x-ui banlog - Check Fail2ban ban logs"
  193. echo -e "x-ui update - Update x-ui"
  194. echo -e "x-ui install - Install x-ui"
  195. echo -e "x-ui uninstall - Uninstall x-ui"
  196. echo -e "----------------------------------------------"
  197. }
  198. echo -e "${green}Running...${plain}"
  199. install_base
  200. install_x-ui $1